% figpol.m
% Disegno di una figura assegnata in coordinate polari

passo=(2*pi)/200;
th=[-pi:passo:pi]; %theta
i=1;
while th(i)<-(pi/2)
   rho(i)=-(2/pi)*th(i);
   i=i+1;
end;
while th(i)<pi/2
   rho(i)=1;
   i=i+1;
end;
while i<=length(th)
   rho(i)=(2/pi)*th(i);
   i=i+1;
end;
figure(1);
clf;
hold off;
polar(th,rho);


% calcola l'area della figura disegnata
hold on;
a1=-2;a2=1;b1=-1.5;b2=1.5;
n=input('numero di numeri casuali');
xx=rand(n,1);
yy=rand(n,1);
x=a1+xx*(a2-a1);
y=b1+yy*(b2-b1);
plot(x,y,'*')

 
   