%Gammakb.m

%Generazione di n numeri casuali a distribuzione
%Gamma(k,b).Istogramma freq.ass.e relative.
%Densita' empirica e teorica.
%Grafico cdf empirica e teorica.

n=input(' quanti numeri generiamo? ');
k=input(' parametro k ');
b=input(' parametro b ');
nb=input(' numero di barre ');
t=cputime;
x=rand(k,n);
for i=1:k
     for j=1:n 
          x(i,j)=-(1/b)*log(1-x(i,j));     % genero punti esponenziali
     end;                                         % con l'inversione della cumulativa 
end;
x=sum(x);                                     %vettore 1*n di n numeri Gamma(k,b)
mini=min(x);
mass=max(x);

figure(1);
clf;
hold off;
subplot(3,1,1);
hist(x,nb);                                 %questo plotta le freq.ass.
title('frequenze assolute' );    

[ord asc]=hist(x,nb);
ord=(1/n)*ord;
subplot(3,1,2);
bar(asc,ord);                            %frequenze relative
title(' frequenze relative' );     

ord=(1/(asc(2)-asc(1)))*ord;
subplot(3,1,3);
bar(asc,ord);                            %densita' empirica 
title(' densita'' empirica e teorica ');
hold on;
passo=(mass-mini)/((nb)^2);
xx=[mini:passo:mass];
uu=gampdf(xx,k,1/b);
plot(xx,uu,'r');                           %densita' teorica
hold on;
yy=(1/sqrt((2*pi*k)/(b^2)))*exp((-0.5.*(xx-k/b).^2)/(k/b^2));
plot(xx,yy,'b');                          % confronto con N(k/b,k/(b^2))
                                                  % Applicaz.Teor.lim.centr.
figure(2);
clf;
hold off;
p=gamcdf(xx,k,1/b);
plot(xx,p,'r');                                %plotta la cdf teorica

z=sort(x);                                     %ordino i dati in ordine crescente 
m=length(xx);
                         
for i=1:m
	ndat=0;
	j=1;
	while j<n & z(j)<=xx(i)
		j=j+1; 
		ndat=ndat+1;
	end;
	cdfe(i)=ndat/n;
end;
hold on;
plot(xx,cdfe,'-g');                         %disegno e confronto cdf emp. e teorica
title('confronto fra cdf empirica(g) e teorica(r): Gamma(k,b)');
tempodicalcolo=cputime-t
 

