%Istfish.m

%Generazione di n numeri casuali a distribuzione
%Fisher(r1,r2).Istogramma freq.ass.e relative.
%Densita' empirica e teorica.
%Grafico cdf empirica e teorica.

clear;
n=input(' quanti numeri di Fisher genero? ');
r1=input(' prima chiquadro con ? ');
r2=input(' seconda chiquadro con ? ');
nb=input(' numero di barre? ');

t=cputime;
x1=chiquad(r1,n);
x2=chiquad(r2,n);
x=(x1./r1)./(x2./r2);

mini=0;
mass=r1;
mass1=max(x);

zz=[mini:(mass-mini)/nb:mass];
figure(1);
clf;
hold off;
subplot(2,1,1);
hist(x,zz);                                 %questo plotta le freq.ass.
[aa,bb]=hist(x,zz);
bar(bb,aa,'g');
title('Fisher: frequenze assolute' );    

[ord asc]=hist(x,zz);
ord=(1/n)*ord;
subplot(2,1,2);
bar(asc,ord,'g');                            %frequenze relative
title(' frequenze relative' );     

ord=(1/(asc(2)-asc(1)))*ord;
figure(2);
clf;
hold off;
bar(asc,ord,'g');                            %densita' empirica e teorica
title(' Fisher: densita'' empirica e teorica ');
hold on;
passo=(mass-mini)/(nb*5);
xx=[mini:passo:mass];
yy=fpdf(xx,r1,r2);
plot(xx,yy,'r');

figure(3);
clf;
hold off;
p=fcdf(xx,r1,r2);
plot(xx,p,'r');                                %plotta la cdf teorica

z=sort(x);                                     %ordino i dati in ordine crescente 
m=max(size(xx));                        %disegno e confronto cdf emp. e teorica
for i=1:m
	ndat=0;
	j=1;
	while j<n & z(j)<=xx(i)
		j=j+1; 
		ndat=ndat+1;
	end;
	cdfe(i)=ndat/n;
end;
hold on;
scala(xx,cdfe,'g');
title('Fisher: cdf empirica e teorica');
axis([0 mass 0 1]);
tempodicalcolo=cputime-t
 

