%Istgamkb.m

%Generazione di n numeri casuali a distribuzione
%Gamma(k,b).Istogramma freq.ass.e relative.
%Densita' empirica e teorica.
%Grafico cdf empirica e teorica.

n=input(' quanti numeri generiamo? ');
k=input(' parametro k ');
b=input(' parametro b ');
nb=input(' numero di barre ');
t=cputime;
x=rand(k,n);
for i=1:k
     for j=1:n 
          x(i,j)=-(1/b)*log(1-x(i,j));     % genero punti esponenziali
     end;                                         % con l'inversione della cumulativa 
end;
x=sum(x);                                     %vettore 1*n di n numeri Gamma(k,b)
mini=min(x);
mass=max(x);

figure(1);
clf;
hold off;
subplot(2,1,1);
hist(x,nb);                                 %questo plotta le freq.ass.
[aa,bb]=hist(x,nb);
bar(bb,aa,'g');
title('Gamma: frequenze assolute' );    

[ord asc]=hist(x,nb);
ord=(1/n)*ord;
subplot(2,1,2);
bar(asc,ord,'g');                            %frequenze relative
title(' frequenze relative' );     

ord=(1/(asc(2)-asc(1)))*ord;
figure(2);
clf;
hold off;
bar(asc,ord,'g');                            %densita' empirica e teorica
title(' Gamma: densita'' empirica e teorica ');
hold on;
passo=(mass-mini)/(nb*5);
xx=[mini:passo:mass];
yy=gampdf(xx,k,1/b);
plot(xx,yy,'r');

figure(3);
clf;
hold off;
p=gamcdf(xx,k,1/b);
plot(xx,p,'r');                                %plotta la cdf teorica

z=sort(x);                                     %ordino i dati in ordine crescente 
m=length(xx);
                         
for i=1:m
	ndat=0;
	j=1;
	while j<n & z(j)<=xx(i)
		j=j+1; 
		ndat=ndat+1;
	end;
	cdfe(i)=ndat/n;
end;
hold on;
scala(xx,cdfe,'-g');                         %disegno e confronto cdf emp. e teorica
title('confronto fra cdf empirica(g) e teorica(r): Gamma(k,b)');
axis([0 mass 0 1]);
tempodicalcolo=cputime-t
 

