%istgeo1.m
                 %%%    Genera m numeri casuali a distribuzione geometrica 
                 %%%    di parametro "p" e disegna l'istogramma delle frequenze 
                 %%%    relative confrontandolo con la densit teorica. Cumulativa
                 %%%    empirica e teorica. 

clear;
p=input('parametro della geometrica?  ');
m=input('quanti numeri genero?  ');

t=cputime;
x=rand(m,1);
x=ceil((log(x))/log(1-p));

bins=[1:max(x)];
figure(1);
clf;
hold off;
subplot(2,1,1);
hist(x,bins);                        % QUESTO PLOTTA LE FREQUENZE ASSOLUTE
[aa,bb]=hist(x,bins);
bar(bb,aa,'g');
title('Distr. geometrica: frequenze assolute')

[ord asc]=hist(x,bins);
ord=(1/m)*ord;
ord=(1/(asc(2)-asc(1)))*ord;
subplot(2,1,2);
bar(asc,ord,'g');                      % DENSITA' EMPIRICA
hold on;
xx=bins;
yy=p*(1-p).^(xx-1);
plot(xx,yy,'Or');                    % DENSITA' TEORICA
title('densit empirica e teorica');

                                            
nn=length(bins);                  % grafico della cumulativa empirica e teorica
cdfe(1)=0;
cdft(1)=0;
for i=1:nn-1
   cdfe(i+1)=cdfe(i)+ord(i);
   cdft(i+1)=cdft(i)+yy(i);
end;
figure(2);
clf;
hold off;
scala(bins,cdfe,'b--');
hold on;
scala(bins,cdft,'r');
title('Geometrica: cdf empirica e teorica');
axis([0 max(x) 0 1]);
tempodicalcolo=cputime-t               