function [xo,yo]=scala(x,y,s)
% SCALA.M 
% Disegna un grafico a scala dei vettori x,y contenenti ascisse
% e ordinate dei punti da unire, rispettivamente.
% Il terzo argomento indica il colore e lo stile della linea da utilizzare
% Esempio: scala(x,y,'-r')

error(nargchk(1,3,nargin));
if nargin==3 
	sym = [s];
else
	sym=[];
end;
a=min(size(x));
b=min(size(y));
if a>1 | b>1
	'ERRORE: i primi due argomenti devono essere vettori e non matrici'
end;
nn=length(x);
asc(1)=x(1);
ord(1)=y(1);
for i=1:nn-1
	k=2*i;
	asc(k)=x(i+1);
	ord(k)=y(i);
	asc(k+1)=x(i+1);
	ord(k+1)=y(i+1);
end;
plot(asc,ord,sym);