% ISTESP1.M

%	Disegno dell'istogramma di n n.c. a distribuzione
%	Esponenziale(l).Istogramma freq.ass.,relat.,confronto con densita' teor.
%              Cdf. empirica e teorica.

l=input('parametro dell''esponenziale');
n=input('n.c. esp. da generare?');
nb=input('n. di barre');           %scelta del n.barre

t=cputime;
x=esp1(l,n);                           %genera n numeri cas.esp.
passo=(max(x))/100 ;               
ww=[0:passo:(max(x))];        %individua le ascisse per 
zz=l.*exp((-l).*ww);                %densita'teorica


figure(1);
clf;
hold off;                  
subplot(2,1,1)                     
hist(x,nb);                              %questo plotta le frequenze assolute
[aa,bb]=hist(x,nb);
bar(bb,aa,'g');
title('Distr. Esponenziale: frequenze assolute')

subplot(2,1,2);
[ord asc]=hist(x,nb);
ord=(1/n)*ord;
bar(asc,ord,'g');                     %questo plotta le frequenze relative
title('frequenze rel.');
 
ord1=(1/(asc(2)-asc(1)))*ord; %riscalo per confrontare con densita'
figure(2);
clf;
hold off;   
bar(asc,ord1,'g');                        %plotta la densita'empirica
title('Distr. Esponenziale: densita'' empirica e teorica')  %densita' empirica e teorica                                                             

hold on;
plot(ww,zz,'r');

nn=length(ord);                     %grafico della cumulativa F empirica e teorica
cdft=ones(size(ww))-exp((-l).*ww); 
cdfe(1)=ord(1);                   
for i=2:nn
   cdfe(i)=cdfe(i-1)+ord(i);
end;

figure(3);
clf;
hold off;
scala(asc,cdfe,'b');
hold on;
plot(ww,cdft,'-r');
title('Esponenziale: cdf empirica e teorica');
axis([0 (max(x)) 0 1]);
tempodicalcolo=cputime-t


