 % area.m

 % Disegno di una figura assegnata in coordinate polari 
 % e calcola l'area con il metodo Montecarlo

clear;
passo=(2*pi)/200;
th=[-pi:passo:pi]; %theta
i=1;
while th(i)<-(pi/2)
   rho(i)=-(2/pi)*th(i);
   i=i+1;
end;
while th(i)<pi/2
   rho(i)=1;
   i=i+1;
end;
while i<=length(th)
   rho(i)=(2/pi)*th(i);
   i=i+1;
end;
figure(1);
clf;
hold off;
polar(th,rho,'r')
title(' calcolo di aree ');

hold on;                                          % calcola area figura
a1=-2;a2=1;b1=-1.2;b2=1.2;

n=input(' numeri casuali da generare:  ');
t=cputime;
xx=rand (n,1);
yy=rand (n,1);
x=a1+xx*(a2-a1);
y=b1+yy*(b2-b1);
if n<5000
    plot(x,y,'.b')
end;

                                     
l1=[-2:0.01:1];                          %disegna il rettangolo
m1=1.2*ones(1,length(l1));
plot(l1,m1,'g')
m2=-1.2*ones(1,length(l1));
plot(l1,m2,'g')
l2=[-1.2:0.01:1.2];
n1=-2*ones(1,length(l2));
plot(n1,l2,'g')
n2=ones(1,length(l2));
plot(n2,l2,'g')

[theta,r]=cart2pol(x,y);   
k1=0;
k2=0;
k3=0;
for j=1:n
       if (abs(theta(j)))<(pi/2) & r(j)<=1
            k1=k1+1; 
         elseif theta(j)>=(pi/2) & theta(j)<=pi & r(j)<=(2/pi)*theta(j)
            k2=k2+1;
         else
            if r(j)<=-(2/pi)*theta(j)
               k3=k3+1;
            end;
       end;
end;

k=k1+k2+k3;
area=7.2*(k/n)
tempodicalcolo=cputime-t
clear;


            