%iststudk.m

% T di student:frequenze assolute e relative,
% densit empirica e teorica, cumulativa empirica e teorica

clear;
n=input('quanti numeri genero? ');
k=input('chiquadro con quale k (intero)? ');
nb=input('numero di barre? ');

t=cputime;
xx=norm01(n);
z=chiquad(k,n);
x=xx./sqrt(z./k);

mini=min(x);
mass=max(x);

figure(1);
clf;
hold off;
subplot(2,1,1);
hist(x,nb);                                 %questo plotta le freq.ass.
[aa,bb]=hist(x,nb);
bar(bb,aa,'g');
title(' T di Student: frequenze assolute' );    

[ord asc]=hist(x,nb);
ord=(1/n)*ord;
subplot(2,1,2);
bar(asc,ord,'g');                            %frequenze relative
title(' frequenze relative' );     

ord=(1/(asc(2)-asc(1)))*ord;
figure(2);
clf;
hold off;
bar(asc,ord,'g');                            %densita' empirica e teorica
title(' T di Student: densita'' empirica(g) teorica(r) e N(0,1)(b) ');
hold on;
passo=(mass-mini)/(nb*10);
xx=[mini:passo:mass];
yy=(1/sqrt(2*pi))*exp(-0.5.*(xx).^2);
plot(xx,yy,'b');                            % N(0,1)
hold on;
tt=tpdf(xx,k);
plot(xx,tt,'r');                               % tpdf
axis([-6 6 0 0.5]);                              

figure(3);
clf;
hold off;
p=tcdf(xx,k);
plot(xx,p,'r');                                %plotta la cdf teorica

z=sort(x);                                     %ordino i dati in ordine crescente 
m=max(size(xx));                        %disegno e confronto cdf emp. e teorica
for i=1:m
	ndat=0;
	j=1;
	while j<n & z(j)<=xx(i)
		j=j+1; 
		ndat=ndat+1;
	end;
	cdfe(i)=ndat/n;
end;
hold on;
scala(xx,cdfe,'-g');
title('confronto fra cum. empirica e cdf teorica: T di Student');
axis([-6 6 0 1]); 
tempodicalcolo=cputime-t
 

