% ISTBERN.M

%	Disegno dell'istogramma di n n.c. a distribuzione
%	Bernoulli(p) e confronto con la distribuzione teorica

n=input('numero di n.c. da generare?  ');
p=input('parametro della Bernoulli  ');

t=cputime;
bins=[0 1];
alt=[1-p p];
x=bern(p,n);

figure(1);
clf;
hold off;
hist(x,bins);                         %questo plotta le frequenze assolute
[aa,bb]=hist(x,bins);
bar(bb,aa,'g');
title('Distr. Bernoulli: frequenze assolute');

figure(2);
clf;
hold off;
[ord asc]=hist(x,bins);
ord=(1/n)*ord;
bar(asc,ord,'g');                  %questo plotta le frequenze relative 
title('distr. Bernoulli: frequenze relative e confronto distr. teorica');
hold on;
plot(bins,alt,'Or');
                                             
nn=max(size(ord));         %grafico della cumulativa empirica e teorica
cdfe(1)=ord(1);
cdft(1)=alt(1);
for i=2:nn
   cdfe(i)=cdfe(i-1)+ord(i);
   cdft(i)=cdft(i-1)+alt(i);
end;
cdfe=[0 cdfe];
cdft=[0 cdft];
bins=[0 bins];

figure(3);
clf;
hold off;
scala(bins,cdfe,'--b');
hold on;
scala(bins,cdft,'-r');
title('Bernoulli: cdf empirica e teorica');
axis([-0.1 1.1 0 1.1]);
axis('square');
tempodicalcolo=cputime-t



