% istchi2k.m

% ChiQuadro con k: frequenze assolute e relative,
% densit empirica e teorica, cumulativa empirica e teorica
             
clear;
n=input(' quanti numeri chiquadro genero? ');
k=input(' parametro k (intero) ? ');
nb=input('numero di barre? ');

t=cputime;
if k==1
     x=norm01(n);
     x=x.^2;
else  for i=1:k
              for j=1:n
                   x(i,j)=norm01(1);                 % matrice kxn di N(0,1)             
              end;
         end;
         x=x.^2;
         x=sum(x);                  % vettore di n chiquadro con k
end;

mini=min(x);
mass=max(x);

figure(1);
clf;
hold off;
subplot(2,1,1);
hist(x,nb);                                 %questo plotta le freq.ass.
[aa,bb]=hist(x,nb);
bar(bb,aa,'g');
title(' Chiquadro: frequenze assolute' );    

[ord asc]=hist(x,nb);
ord=(1/n)*ord;
subplot(2,1,2);
bar(asc,ord,'g');                            %frequenze relative
title(' frequenze relative' );     

ord=(1/(asc(2)-asc(1)))*ord;
figure(2);
clf;
hold off;
bar(asc,ord,'g');                            %densita' empirica e teorica
title(' Chiquadro: densita'' empirica e teorica ');
hold on;
passo=(mass-mini)/(nb*5);
xx=[mini:passo:mass];
yy=chi2pdf(xx,k);          
plot(xx,yy,'r');

figure(3);
clf;
hold off;
p=chi2cdf(xx,k);
plot(xx,p,'r');                                %plotta la cdf teorica

z=sort(x);                                     %ordino i dati in ordine crescente 
m=max(size(xx));                        %disegno e confronto cdf emp. e teorica
for i=1:m
	ndat=0;
	j=1;
	while j<n & z(j)<=xx(i)
		j=j+1; 
		ndat=ndat+1;
	end;
	cdfe(i)=ndat/n;
end;
hold on;
scala(xx,cdfe,'g');
title('confronto fra cdf. empirica e teorica: ChiQuadro ');
axis([0 mass 0 1]);
tempodicalcolo=cputime-t
 

