% istdadi.m
% lancio d dadi n volte. Istogramma frequenze assolute e relative e confronto
% con  la normale

d=input('quanti dadi?');              % generazione di n numeri interi casuali uniformi in (a,b)
n=input('quanti lanci?');
t=cputime;
a=1;
b=6;
x=rand(d,n);
y=a+(b-a+1).*x;
z=floor(y);

somma=sum(z);                        %vettore 1*n
bins=[d:(6*d)];
figure(1);
clf;
hold off;
subplot(2,1,1);
hist(somma,bins);                      %questo plotta le frequenze assolute
[aa,bb]=hist(somma,bins);
bar(bb,aa,'g');
title(' somma di dadi: frequenze assolute')

[ord asc]=hist(somma,bins);
ord=(1/n)*ord;
subplot(2,1,2);
bar(asc,ord,'g');                              %questo plotta le frequenze relative 
title(' frequenze relative');

ord=(1/(asc(2)-asc(1)))*ord;
figure(2)
hold off;
clf;
bar(asc, ord,'g');
hold on;

media=d*7/2;
varianza=35*d/12;
xx=[d:0.1:(6*d)];                         % vettori per disegnare la densita'
yy=(1/(sqrt(2*pi*varianza)))*exp(-((xx-media).^2)/(2*varianza));
plot(xx,yy,'r');
title('somma di dadi: confronto con la normale ');
tempodicalcolo=cputime-t
