% ISTNOR01.m

% Generazione di n numeri N(0,1).Istogramma freq.ass.e relative.
% Densit empirica e teorica.
% Cumulativa empirica e teorica.

clear;
n=input(' quanti numeri normali genero? ');
nb=input('numero di barre? ');
t=cputime;
y=rand(12,n);
x=sum(y)-6;
mini=min(x);
mass=max(x);

figure(1);
clf;
hold off;
subplot(2,1,1);
hist(x,nb);                                 %questo plotta le freq.ass.
[aa,bb]=hist(x,nb);
bar(bb,aa,'g');
title('N(0,1) frequenze assolute' );    

[ord asc]=hist(x,nb);
ord=(1/n)*ord;
subplot(2,1,2);
bar(asc,ord,'g');                            %frequenze relative
title(' frequenze relative' );     

ord=(1/(asc(2)-asc(1)))*ord;
figure(2);
clf;
hold off;
bar(asc,ord,'g');                            %densita' empirica e teorica
title('N(0,1): densita'' empirica e teorica ');
hold on;
passo=(mass-mini)/(nb*5);
xx=[mini:passo:mass];
yy=(1/sqrt(2*pi))*exp(-0.5.*(xx).^2);
plot(xx,yy,'r');

figure(3);
clf;
hold off;
p=normcdf(xx,0,1);
plot(xx,p,'r');                                %plotta la cdf teorica

z=sort(x);                                     %ordino i dati in ordine crescente 
m=max(size(xx));                        %disegno e confronto cdf emp. e teorica
for i=1:m
	ndat=0;
	j=1;
	while j<n & z(j)<=xx(i)
		j=j+1; 
		ndat=ndat+1;
	end;
	cdfe(i)=ndat/n;
end;
hold on;
scala(xx,cdfe,'g');
title('confronto fra cdf empirica e teorica: N(0,1)');
tempodicalcolo=cputime-t
 

